﻿Imports System.IO
Imports System.Net
Imports System.Text

Module Module1

    Sub Main(args As String())

        Dim POST = True
        Dim result As String

        If args.Length <> 2 Then
            Console.Out.WriteLine("usage: <input json request file> <output json result file>")

            Console.Out.WriteLine()
            Console.Out.WriteLine("Press any key to exit.")
            Console.ReadKey()
            Return
        End If
        Try
            Dim inFilePath = args(0)
            Dim outFilePath = args(1)

            Dim readJson As String = Replace(File.ReadAllText(inFilePath), vbTab, "")
            readJson = Replace(readJson, vbLf, "")

            If POST Then
                Dim data = Encoding.UTF8.GetBytes(readJson)
                Dim url = "http://optimizer2.routesavvy.com/RSAPI.svc/POSTOptimize"
                Dim req As WebRequest = WebRequest.Create(url)
                req.ContentType = "application/json"
                req.Method = "POST"
                req.ContentLength = data.Length


                Dim stream = req.GetRequestStream()
                stream.Write(data, 0, data.Length)
                stream.Close()

                Dim response = req.GetResponse().GetResponseStream()

                Dim reader As New StreamReader(response)
                result = reader.ReadToEnd()
                reader.Close()
                response.Close()

                Console.Out.WriteLine(result)

            Else
                Dim url = "http://optimizer2.routesavvy.com/RSAPI.svc/GETOptimize?query="

                Dim request As HttpWebRequest = TryCast(WebRequest.Create(url + readJson), HttpWebRequest)
                Dim response As HttpWebResponse = TryCast(request.GetResponse(), HttpWebResponse)
                Dim reader As New StreamReader(response.GetResponseStream())
                result = reader.ReadToEnd()

                reader.Close()
                response.Close()

                Console.Out.WriteLine(result)

            End If


            Dim fileOut As System.IO.StreamWriter
            fileOut = My.Computer.FileSystem.OpenTextFileWriter(outFilePath, True)
            fileOut.WriteLine(result)
            fileOut.Close()

        Catch ex As System.IO.IOException
            Console.Out.WriteLine("Exception :" + ex.Message)
        End Try
        Console.Out.WriteLine()
        Console.Out.WriteLine("Press any key to exit.")
        Console.ReadKey()
    End Sub

End Module
